Public NotInheritable Class ClsAnalyse
    Inherits ClsBaseThread

    Private mUDCopy As NumericUpDown 'Nombre de copies simultanes
    Private mList As SortedList 'Liste des fichiers  dplacer
    Private mRetryList As SortedList 'TODO :  implmenter
    Private mDoAnalyse As Boolean = False 'Analysse en cours ou  faire ?
    Private mLstDir As NHenry.Scandir.ClsScandir 'Scan des dossiers
    Private mCutFiles As Boolean 'Dcouper les fichiers trop gros pour tenir dans un seul support
    Private mCutOnly As Boolean 'Dcouper seulement les fichiers pouvant tre mis sur tous les supports pour cette fois seulement
    Private mNbCopy As Integer 'Nombre maximum de copies simultanes (0 : maximum)
    Friend Sub New(ByVal pUDNbCopy As NumericUpDown, ByVal pLstDir As NHenry.Scandir.ClsScandir, ByVal pLstFiles As SortedList)
        MyBase.New("Thread d'analyse et de gestion des copies")
        mUDCopy = pUDNbCopy
        mList = pLstFiles
        mLstDir = pLstDir
        mCutFiles = CBool(GetSetting("CutToKey", "Config", "Cutfiles", "False"))
        mCutOnly = CBool(GetSetting("CutToKey", "Config", "CutOnlyFreeSpace", "True"))
    End Sub

    Public Property DoAnalyse() As Boolean
        Get
            Return mDoAnalyse
        End Get
        Set(ByVal Value As Boolean)
            mDoAnalyse = Value
        End Set
    End Property
    Public ReadOnly Property CanStopApp() As Boolean
        Get
            Return Not (mDoAnalyse Or ClsDrive.GetNbCopy > 0)
        End Get
    End Property

    Public Property CutFiles() As Boolean
        Get
            Return mCutFiles
        End Get
        Set(ByVal Value As Boolean)
            mCutFiles = Value
            SaveSetting("CutToKey", "Config", "CutFiles", Value.ToString)
        End Set
    End Property
    Public Property CutOnlyFreeSpace() As Boolean
        Get
            Return mCutOnly
        End Get
        Set(ByVal Value As Boolean)
            mCutOnly = Value
            SaveSetting("CutToKey", "Config", "CutOnlyFreeSpace", Value.ToString)
        End Set
    End Property

#Region "Mthodes du thread"
    Protected Overrides Sub Run()
        Dim lFile As NHenry.Scandir.TFile
        Dim i As Integer
        Dim lMax As Integer
        Dim lTh As ClsBaseThread
        Do While MyBase.mCanRun And MyBase.msCanRun
            If mDoAnalyse Then
                Do While mDoAnalyse And MyBase.mCanRun And MyBase.msCanRun
                    If MajLst() = False Then Exit Do
                    MyBase.Sleep(10)
                Loop
                Do While ClsDrive.GetNbCopy > 0 And mDoAnalyse And MyBase.mCanRun And MyBase.msCanRun
                    MyBase.Sleep(100)
                Loop
                Do While mDoAnalyse And MyBase.mCanRun And MyBase.msCanRun And mList.Count > 0
                    Try
                        lFile = DirectCast(mList.GetByIndex(0), NHenry.Scandir.TFile)
                        Dim lLength As UInt64 = Convert.ToUInt64(lFile.Length)
                        For Each lTh In ClsBaseThread.msLstThreads
                            If TypeOf lTh Is ClsDrive AndAlso DirectCast(lTh, ClsDrive).GetFreeSpace.CompareTo(lLength) >= 0 Then
                                lFile.FileName = ""
                                Exit For
                            End If
                        Next
                        If lFile.FileName <> "" Then
                            Exit Do
                        End If
                    Catch ex As Exception
                    End Try
                    MyBase.Sleep(100)
                Loop
                mDoAnalyse = False
            Else
                SyncLock mList
                    If mList.Count > 0 Then mList.Clear()
                End SyncLock
                Try
                    For Each lTh1 As ClsBaseThread In ClsBaseThread.msLstThreads
                        If mDoAnalyse Then Throw New Exception
                        If TypeOf lTh1 Is ClsDrive Then
                            DirectCast(lTh1, ClsDrive).RefreshSize(False)
                            MyBase.Sleep(100)
                        End If
                    Next
                Catch ex As Exception
                End Try
            End If
            MyBase.Sleep(10)
        Loop
    End Sub
    Private Function MajLst() As Boolean
        Dim lFile As NHenry.Scandir.TFile
        Dim lStr As String
        Dim i As Integer
        If mLstDir.GetNext(False, False).FileName = "" Then Return False
        Do While mLstDir.GetNext(False, False).FileName.Trim <> ""
            lFile = mLstDir.GetNext(False, True)
            lStr = lFile.Length.ToString
            Do While lStr.Length < 15
                lStr = "0" + lStr
            Loop
            i = 0
            Do While Not (mList.Item(lStr + Chr(i + 33)) Is Nothing)
                i += 1
                If i = 127 Then i = 128
            Loop
            mList.Add(lStr + Chr(i + 33), lFile)
        Loop
        Return True
    End Function

    Protected Overrides Sub SubError(ByRef pEx As System.Exception)
        Throw pEx
    End Sub

    Protected Overrides Sub EndThread()

    End Sub
#End Region
End Class
