Imports System.Reflection

Public Class CtlAnim
    Inherits System.Windows.Forms.UserControl

    Public Enum EEtat
        Aucun = 0
        Scan
        Wait
    End Enum

    Private mEtat As EEtat = EEtat.Aucun
    Private mEtape As Integer = -1

    Private mLstAnalyse As New ArrayList
    Private mLstWait As New ArrayList

#Region " Code gnr par le Concepteur Windows Form "

    Public Sub New()
        MyBase.New()

        'Cet appel est requis par le Concepteur Windows Form.
        InitializeComponent()

        'Ajoutez une initialisation quelconque aprs l'appel InitializeComponent()

    End Sub

    'La mthode substitue Dispose du UserControl pour nettoyer la liste des composants.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Requis par le Concepteur Windows Form
    Private components As System.ComponentModel.IContainer

    'REMARQUE: la procdure suivante est requise par le Concepteur Windows Form
    'Elle peut tre modifie en utilisant le Concepteur Windows Form.  
    'Ne la modifiez pas en utilisant l'diteur de code.
    Friend WithEvents Pict As System.Windows.Forms.PictureBox
    Friend WithEvents TRefresh As System.Windows.Forms.Timer
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.Pict = New System.Windows.Forms.PictureBox
        Me.TRefresh = New System.Windows.Forms.Timer(Me.components)
        Me.SuspendLayout()
        '
        'Pict
        '
        Me.Pict.BackColor = System.Drawing.Color.Transparent
        Me.Pict.Location = New System.Drawing.Point(0, 0)
        Me.Pict.Name = "Pict"
        Me.Pict.Size = New System.Drawing.Size(32, 32)
        Me.Pict.SizeMode = System.Windows.Forms.PictureBoxSizeMode.CenterImage
        Me.Pict.TabIndex = 0
        Me.Pict.TabStop = False
        '
        'TRefresh
        '
        Me.TRefresh.Interval = 250
        '
        'CtlAnim
        '
        Me.Controls.Add(Me.Pict)
        Me.Name = "CtlAnim"
        Me.Size = New System.Drawing.Size(104, 88)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub CtlAnim_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim lAssembly As [Assembly] = [Assembly].GetExecutingAssembly
        Me.Size = New Size(32, 32)
        Pict.Tag = Nothing
        Pict.Image = Nothing
        Dim i As Integer = 0
        Dim lFileName As String = "Scan"
        Dim lExt As String = ".png"
        Try
            i = 0
            Do While True
                mLstAnalyse.Add(New Bitmap(lAssembly.GetManifestResourceStream(Me.GetType.Namespace + "." + lFileName + i.ToString + lExt)))
                i += 1
            Loop
        Catch ex As Exception
        End Try
        lFileName = "Wait"
        Try
            i = 0
            Do While True
                mLstWait.Add(New Bitmap(lAssembly.GetManifestResourceStream(Me.GetType.Namespace + "." + lFileName + i.ToString + lExt)))
                i += 1
            Loop
        Catch ex As Exception
        End Try
    End Sub
    Private Sub CtlAnim_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        If Me.Size.Height <> 32 OrElse Me.Size.Width <> 32 Then Me.Size = New Size(32, 32)
    End Sub

    Private Sub TRefresh_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TRefresh.Tick
        Select Case mEtat
            Case EEtat.Aucun
                Pict.Image = Nothing
                TRefresh.Enabled = False
            Case EEtat.Scan
                Dim lLst As ArrayList = mLstAnalyse
                If 0 = llst.Count Then
                    Pict.Image = Nothing
                    TRefresh.Enabled = False
                    Exit Sub
                End If
                mEtape = (mEtape + 1) Mod lLst.Count
                Pict.Image = DirectCast(lLst.item(mEtape), Bitmap)
            Case EEtat.Wait
                Dim lLst As ArrayList = mLstWait
                If 0 = llst.Count Then
                    Pict.Image = Nothing
                    TRefresh.Enabled = False
                    Exit Sub
                End If
                mEtape = (mEtape + 1) Mod lLst.Count
                Pict.Image = DirectCast(lLst.item(mEtape), Bitmap)
        End Select
    End Sub

    Public Property Etat() As EEtat
        Get
            Return mEtat
        End Get
        Set(ByVal Value As EEtat)
            If Value = mEtat Then Exit Property
            If Value = EEtat.Aucun Or Value = EEtat.Scan Or Value = EEtat.Wait Then
                mEtat = Value
                mEtape = -1
            Else
                mEtat = EEtat.Aucun
            End If
            TRefresh.Enabled = True
        End Set
    End Property
End Class
